
using Json2CSharpCodeGenerator.Lib;
using Json2CSharpCodeGenerator.Lib.CodeWriters;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Json2CSharpCodeGenerator.Tests;

[TestClass]
public class Test_0_DIAGNOSTICS
{
    [TestMethod]
    public void Run()
    {
        // Assert.Inconclusive(message: "This test is not yet implemented.");

        string path = Path.Combine(AppContext.BaseDirectory, "Test_0_DIAGNOSTICS_INPUT.txt");
        string resultPath = Path.Combine(AppContext.BaseDirectory, "Test_0_DIAGNOSTICS_OUTPUT.txt");
        string input = File.ReadAllText(path);
        CSharpCodeWriter csharpCodeWriter = new();
        JsonClassGenerator jsonClassGenerator = new()
        {
            CodeWriter = csharpCodeWriter,

            AttributeLibrary = JsonLibrary.SystemTextJson
        };

        string returnVal = jsonClassGenerator.GenerateClasses(input, errorMessage: out _).ToString();
        string resultsCompare = File.ReadAllText(resultPath);

        string expected = resultsCompare.NormalizeOutput();
        string actual = returnVal.NormalizeOutput();
        if (expected != actual)
        {
            File.WriteAllText(Path.Combine(AppContext.BaseDirectory, "Test_0_DIAGNOSTICS_OUTPUT.actual.txt"), returnVal);
            File.WriteAllText(Path.Combine(AppContext.BaseDirectory, "Test_0_DIAGNOSTICS_OUTPUT.expected.txt"), resultsCompare);
        }
        Assert.AreEqual(expected, actual);
    }
}